(function ($, Drupal, drupalSettings) {

  var settings = drupalSettings.edlp_studio;

  function init(){
    console.log('Studio Init');
    initEvents();
    initAjaxChutier();
  };

  function initEvents(){
    $('body')
      .on('new-audio-cartel-loaded', initAjaxChutier)
      .on('new-content-ajax-loaded', initAjaxChutier);
  };


  //   ___ _        _   _           _  _         _       _    _      _
  //  / __| |_ _  _| |_(_)___ _ _  | \| |___  __| |___  | |  (_)_ _ | |__ ___
  // | (__| ' \ || |  _| / -_) '_| | .` / _ \/ _` / -_) | |__| | ' \| / /(_-<
  //  \___|_||_\_,_|\__|_\___|_|   |_|\_\___/\__,_\___| |____|_|_||_|_\_\/__/

  function initAjaxChutier(){
    console.log('studio initAjax chutier');
    $('.chutier-ajax-link:not(.ajax-enabled)')
      .addClass('ajax-enabled')
      .on('click', onClickChutierAjaxLink);
  };

  function onClickChutierAjaxLink(e){
    console.log('studio onClickAjaxLink chutier');
    e.preventDefault();
    addRemoveToChutier($(this));
    return false;
  };

  function addRemoveToChutier($link){
    // var ajax_path = 'edlp_studio/ajax/chutier/add/'+id; // + '/' +cid;
    var ajax_path = $link.attr('data-drupal-link-system-path');
    var path = window.location.origin + drupalSettings.path.baseUrl + ajax_path;
    $link.addClass('ajax-loading');
    $.getJSON(path, {})
      .done(function(data){
        onActionToChutierDone($link, data);
      })
      .fail(function(jqxhr, textStatus, error){
        onErrorActionToChutier(jqxhr, textStatus, error, $link);
      });
  };

  function onActionToChutierDone($link, data){
    console.log('onActionToChutierDone',data);
    $('body').trigger({
      'type':'chutier-action-done',
      'action_done':data.action_done,
      'new_action':data.action_done == 'add' ? 'remove' : 'add',
      'target_id':$link.attr('target_id'),
    });
    $link.replaceWith(data.new_link);
    initAjaxChutier();
    updateStudioChutier();
    // TODO: reload Studio chutier_ui's documents list
  };

  function onErrorActionToChutier(jqxhr, textStatus, error, $link){
    console.warn('add to chuttier load failed : '+error, jqxhr.responseText);
  };


  //  ___ _           _ _              _
  // / __| |_ _  _ __| (_)___ ___ _  _(_)
  // \__ \  _| || / _` | / _ \___| || | |
  // |___/\__|\_,_\__,_|_\___/    \_,_|_|
  // this seems dirty
  function updateStudioChutier(){
    $studioChutier = $('#studio-ui .chutier_ui');
    if($studioChutier.length){
      var ajax_path = settings.chutier_ui_ajax;
      var path = window.location.origin + drupalSettings.path.baseUrl + ajax_path;
      $studioChutier.addClass('loading');
      $.getJSON(path, {})
        .done(function(data){
          onLoadedChutier($studioChutier, data);
        })
        .fail(function(jqxhr, textStatus, error){
          onLoadChutierError(jqxhr, textStatus, error, $studioChutier);
        });
    }
  };

  function onLoadedChutier($studioChutier, data){
    $studioChutier.replaceWith(data.rendered);
    initAjaxChutier();
    $('body').trigger({
      'type':'on-studio-chutier-updated'
    });
  }

  function onLoadChutierError(jqxhr, textStatus, error, $studioChutier){
    console.warn('Chutier load failed', jqxhr.responseText);
    $studioChutier.removeClass('loading');

  }

  init();
})(jQuery, Drupal, drupalSettings);
